From 9c6bf2d8ef405d42257de71f2928527c81424d3e Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 26 2020 01:02:12 +0000
Subject: [PATCH 404/2232] Remove assumption of Vec field order


---

diff --git a/gen/write.rs b/gen/write.rs
index deae886..faf3311 100644
--- a/gen/write.rs
+++ b/gen/write.rs
@@ -147,6 +147,7 @@ fn write_include_cxxbridge(out: &mut OutFile, apis: &[Api], types: &Types) {
                 needs_rust_box = true;
             }
             Type::RustVec(_) => {
+                out.include.array = true;
                 needs_rust_vec = true;
             }
             Type::Str(_) => {
diff --git a/include/cxx.h b/include/cxx.h
index c62faad..1df6c9b 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -97,10 +97,8 @@ private:
   Vec &operator=(Vec other) noexcept;
   void drop() noexcept;
 
-  // Repr
-  const T *ptr;
-  size_t len;
-  size_t capacity;
+  // Size and alignment statically verified by rust_vec.rs.
+  std::array<uintptr_t, 3> repr;
 };
 #endif // CXXBRIDGE02_RUST_VEC
 
diff --git a/src/rust_vec.rs b/src/rust_vec.rs
index a8a144a..1c0c64f 100644
--- a/src/rust_vec.rs
+++ b/src/rust_vec.rs
@@ -1,3 +1,5 @@
+use std::mem;
+
 #[repr(C)]
 pub struct RustVec<T> {
     repr: Vec<T>,
@@ -28,3 +30,6 @@ impl<T> RustVec<T> {
         self.repr.len()
     }
 }
+
+const_assert_eq!(mem::size_of::<[usize; 3]>(), mem::size_of::<Vec<i32>>());
+const_assert_eq!(mem::align_of::<usize>(), mem::align_of::<Vec<i32>>());

